diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-raw-socket-impl.h ns-3.39/src/internet/model/ipv6-raw-socket-impl.h
--- ns-3.38/src/internet/model/ipv6-raw-socket-impl.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-raw-socket-impl.h	2023-07-05 14:23:47.853427400 -0700
@@ -80,13 +80,13 @@
      */
     void SetNode(Ptr<Node> node);
 
-    enum Socket::SocketErrno GetErrno() const override;
+    Socket::SocketErrno GetErrno() const override;
 
     /**
      * \brief Get socket type (NS3_SOCK_RAW)
      * \return socket type
      */
-    enum Socket::SocketType GetSocketType() const override;
+    Socket::SocketType GetSocketType() const override;
 
     Ptr<Node> GetNode() const override;
 
@@ -185,7 +185,7 @@
     /**
      * \brief Last error number.
      */
-    mutable enum Socket::SocketErrno m_err;
+    mutable Socket::SocketErrno m_err;
 
     /**
      * \brief Node.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-routing-protocol.cc ns-3.39/src/internet/model/ipv6-routing-protocol.cc
--- ns-3.38/src/internet/model/ipv6-routing-protocol.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-routing-protocol.cc	2023-07-05 14:23:47.853427400 -0700
@@ -19,8 +19,6 @@
 
 #include "ipv6-routing-protocol.h"
 
-#include "ipv6-route.h"
-
 #include "ns3/assert.h"
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-routing-protocol.h ns-3.39/src/internet/model/ipv6-routing-protocol.h
--- ns-3.38/src/internet/model/ipv6-routing-protocol.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-routing-protocol.h	2023-07-05 14:23:47.853427400 -0700
@@ -132,10 +132,10 @@
     virtual bool RouteInput(Ptr<const Packet> p,
                             const Ipv6Header& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb) = 0;
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb) = 0;
 
     /**
      * \brief Notify when specified interface goes UP.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-routing-table-entry.cc ns-3.39/src/internet/model/ipv6-routing-table-entry.cc
--- ns-3.38/src/internet/model/ipv6-routing-table-entry.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-routing-table-entry.cc	2023-07-05 14:23:47.853427400 -0700
@@ -121,11 +121,7 @@
 bool
 Ipv6RoutingTableEntry::IsHost() const
 {
-    if (m_destNetworkPrefix == Ipv6Prefix::GetOnes())
-    {
-        return true;
-    }
-    return false;
+    return m_destNetworkPrefix == Ipv6Prefix::GetOnes();
 }
 
 Ipv6Address
@@ -155,11 +151,7 @@
 bool
 Ipv6RoutingTableEntry::IsDefault() const
 {
-    if (m_dest == Ipv6Address::GetZero())
-    {
-        return true;
-    }
-    return false;
+    return m_dest == Ipv6Address::GetZero();
 }
 
 Ipv6Address
@@ -177,11 +169,7 @@
 bool
 Ipv6RoutingTableEntry::IsGateway() const
 {
-    if (m_gateway == Ipv6Address::GetZero())
-    {
-        return false;
-    }
-    return true;
+    return m_gateway != Ipv6Address::GetZero();
 }
 
 Ipv6Address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-static-routing.cc ns-3.39/src/internet/model/ipv6-static-routing.cc
--- ns-3.38/src/internet/model/ipv6-static-routing.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-static-routing.cc	2023-07-05 14:23:47.853427400 -0700
@@ -19,9 +19,9 @@
 
 #include "ipv6-static-routing.h"
 
+#include "ipv6-route.h"
 #include "ipv6-routing-table-entry.h"
 
-#include "ns3/ipv6-route.h"
 #include "ns3/log.h"
 #include "ns3/names.h"
 #include "ns3/net-device.h"
@@ -715,10 +715,10 @@
 Ipv6StaticRouting::RouteInput(Ptr<const Packet> p,
                               const Ipv6Header& header,
                               Ptr<const NetDevice> idev,
-                              UnicastForwardCallback ucb,
-                              MulticastForwardCallback mcb,
-                              LocalDeliverCallback lcb,
-                              ErrorCallback ecb)
+                              const UnicastForwardCallback& ucb,
+                              const MulticastForwardCallback& mcb,
+                              const LocalDeliverCallback& lcb,
+                              const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p << header << header.GetSource() << header.GetDestination() << idev);
     NS_ASSERT(m_ipv6);
@@ -750,7 +750,7 @@
     }
 
     // Check if input device supports IP forwarding
-    if (m_ipv6->IsForwarding(iif) == false)
+    if (!m_ipv6->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         if (!ecb.IsNull())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ipv6-static-routing.h ns-3.39/src/internet/model/ipv6-static-routing.h
--- ns-3.38/src/internet/model/ipv6-static-routing.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ipv6-static-routing.h	2023-07-05 14:23:47.853427400 -0700
@@ -257,10 +257,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv6Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
 
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/rip.cc ns-3.39/src/internet/model/rip.cc
--- ns-3.38/src/internet/model/rip.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/rip.cc	2023-07-05 14:23:47.857427600 -0700
@@ -19,18 +19,19 @@
 
 #include "rip.h"
 
+#include "ipv4-packet-info-tag.h"
+#include "ipv4-route.h"
+#include "loopback-net-device.h"
+#include "rip-header.h"
+#include "udp-header.h"
+
 #include "ns3/abort.h"
 #include "ns3/assert.h"
 #include "ns3/enum.h"
-#include "ns3/ipv4-packet-info-tag.h"
-#include "ns3/ipv4-route.h"
 #include "ns3/log.h"
-#include "ns3/loopback-net-device.h"
 #include "ns3/names.h"
 #include "ns3/node.h"
 #include "ns3/random-variable-stream.h"
-#include "ns3/rip-header.h"
-#include "ns3/udp-header.h"
 #include "ns3/uinteger.h"
 
 #include <iomanip>
@@ -153,7 +154,7 @@
         for (uint32_t j = 0; j < m_ipv4->GetNAddresses(i); j++)
         {
             Ipv4InterfaceAddress address = m_ipv4->GetAddress(i, j);
-            if (address.GetScope() != Ipv4InterfaceAddress::HOST && activeInterface == true)
+            if (address.GetScope() != Ipv4InterfaceAddress::HOST && activeInterface)
             {
                 NS_LOG_LOGIC("RIP: adding socket to " << address.GetLocal());
                 TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
@@ -241,10 +242,10 @@
 Rip::RouteInput(Ptr<const Packet> p,
                 const Ipv4Header& header,
                 Ptr<const NetDevice> idev,
-                UnicastForwardCallback ucb,
-                MulticastForwardCallback mcb,
-                LocalDeliverCallback lcb,
-                ErrorCallback ecb)
+                const UnicastForwardCallback& ucb,
+                const MulticastForwardCallback& mcb,
+                const LocalDeliverCallback& lcb,
+                const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p << header << header.GetSource() << header.GetDestination() << idev);
 
@@ -290,7 +291,7 @@
     }
 
     // Check if input device supports IP forwarding
-    if (m_ipv4->IsForwarding(iif) == false)
+    if (!m_ipv4->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         if (!ecb.IsNull())
@@ -365,8 +366,7 @@
     {
         Ipv4InterfaceAddress address = m_ipv4->GetAddress(i, j);
 
-        if (address.GetScope() != Ipv4InterfaceAddress::HOST && sendSocketFound == false &&
-            activeInterface == true)
+        if (address.GetScope() != Ipv4InterfaceAddress::HOST && !sendSocketFound && activeInterface)
         {
             NS_LOG_LOGIC("RIP: adding sending socket to " << address.GetLocal());
             TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/rip.h ns-3.39/src/internet/model/rip.h
--- ns-3.38/src/internet/model/rip.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/rip.h	2023-07-05 14:23:47.857427600 -0700
@@ -192,10 +192,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv4Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
     void NotifyAddAddress(uint32_t interface, Ipv4InterfaceAddress address) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ripng.cc ns-3.39/src/internet/model/ripng.cc
--- ns-3.38/src/internet/model/ripng.cc	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ripng.cc	2023-07-05 14:23:47.857427600 -0700
@@ -19,18 +19,19 @@
 
 #include "ripng.h"
 
+#include "ipv6-packet-info-tag.h"
+#include "ipv6-route.h"
+#include "ripng-header.h"
+#include "udp-header.h"
+
 #include "ns3/abort.h"
 #include "ns3/assert.h"
 #include "ns3/enum.h"
-#include "ns3/ipv6-packet-info-tag.h"
-#include "ns3/ipv6-route.h"
 #include "ns3/log.h"
 #include "ns3/names.h"
 #include "ns3/node.h"
 #include "ns3/random-variable-stream.h"
-#include "ns3/ripng-header.h"
 #include "ns3/simulator.h"
-#include "ns3/udp-header.h"
 #include "ns3/uinteger.h"
 
 #include <iomanip>
@@ -147,7 +148,7 @@
         for (uint32_t j = 0; j < m_ipv6->GetNAddresses(i); j++)
         {
             Ipv6InterfaceAddress address = m_ipv6->GetAddress(i, j);
-            if (address.GetScope() == Ipv6InterfaceAddress::LINKLOCAL && activeInterface == true)
+            if (address.GetScope() == Ipv6InterfaceAddress::LINKLOCAL && activeInterface)
             {
                 NS_LOG_LOGIC("RIPng: adding socket to " << address.GetAddress());
                 TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
@@ -233,10 +234,10 @@
 RipNg::RouteInput(Ptr<const Packet> p,
                   const Ipv6Header& header,
                   Ptr<const NetDevice> idev,
-                  UnicastForwardCallback ucb,
-                  MulticastForwardCallback mcb,
-                  LocalDeliverCallback lcb,
-                  ErrorCallback ecb)
+                  const UnicastForwardCallback& ucb,
+                  const MulticastForwardCallback& mcb,
+                  const LocalDeliverCallback& lcb,
+                  const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p << header << header.GetSource() << header.GetDestination() << idev);
 
@@ -263,7 +264,7 @@
     }
 
     // Check if input device supports IP forwarding
-    if (m_ipv6->IsForwarding(iif) == false)
+    if (!m_ipv6->IsForwarding(iif))
     {
         NS_LOG_LOGIC("Forwarding disabled for this interface");
         if (!ecb.IsNull())
@@ -332,8 +333,8 @@
     {
         Ipv6InterfaceAddress address = m_ipv6->GetAddress(i, j);
 
-        if (address.GetScope() == Ipv6InterfaceAddress::LINKLOCAL && sendSocketFound == false &&
-            activeInterface == true)
+        if (address.GetScope() == Ipv6InterfaceAddress::LINKLOCAL && !sendSocketFound &&
+            activeInterface)
         {
             NS_LOG_LOGIC("RIPng: adding sending socket to " << address.GetAddress());
             TypeId tid = TypeId::LookupByName("ns3::UdpSocketFactory");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/ripng.h ns-3.39/src/internet/model/ripng.h
--- ns-3.38/src/internet/model/ripng.h	2023-03-16 20:54:23.620868400 -0700
+++ ns-3.39/src/internet/model/ripng.h	2023-07-05 14:23:47.857427600 -0700
@@ -194,10 +194,10 @@
     bool RouteInput(Ptr<const Packet> p,
                     const Ipv6Header& header,
                     Ptr<const NetDevice> idev,
-                    UnicastForwardCallback ucb,
-                    MulticastForwardCallback mcb,
-                    LocalDeliverCallback lcb,
-                    ErrorCallback ecb) override;
+                    const UnicastForwardCallback& ucb,
+                    const MulticastForwardCallback& mcb,
+                    const LocalDeliverCallback& lcb,
+                    const ErrorCallback& ecb) override;
     void NotifyInterfaceUp(uint32_t interface) override;
     void NotifyInterfaceDown(uint32_t interface) override;
     void NotifyAddAddress(uint32_t interface, Ipv6InterfaceAddress address) override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-dctcp.cc ns-3.39/src/internet/model/tcp-dctcp.cc
--- ns-3.38/src/internet/model/tcp-dctcp.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-dctcp.cc	2023-07-05 14:23:47.857427600 -0700
@@ -20,9 +20,10 @@
 
 #include "tcp-dctcp.h"
 
+#include "tcp-socket-state.h"
+
 #include "ns3/abort.h"
 #include "ns3/log.h"
-#include "ns3/tcp-socket-state.h"
 
 namespace ns3
 {
@@ -142,7 +143,7 @@
     {
         m_ackedBytesEcn += segmentsAcked * tcb->m_segmentSize;
     }
-    if (m_nextSeqFlag == false)
+    if (!m_nextSeqFlag)
     {
         m_nextSeq = tcb->m_nextTxSequence;
         m_nextSeqFlag = true;
@@ -196,7 +197,7 @@
         tcb->m_rxBuffer->SetNextRxSequence(tmpRcvNxt);
     }
 
-    if (m_priorRcvNxtFlag == false)
+    if (!m_priorRcvNxtFlag)
     {
         m_priorRcvNxtFlag = true;
     }
@@ -223,7 +224,7 @@
         tcb->m_rxBuffer->SetNextRxSequence(tmpRcvNxt);
     }
 
-    if (m_priorRcvNxtFlag == false)
+    if (!m_priorRcvNxtFlag)
     {
         m_priorRcvNxtFlag = true;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-l4-protocol.cc ns-3.39/src/internet/model/tcp-l4-protocol.cc
--- ns-3.38/src/internet/model/tcp-l4-protocol.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-l4-protocol.cc	2023-07-05 14:23:47.857427600 -0700
@@ -21,10 +21,12 @@
 
 #include "ipv4-end-point-demux.h"
 #include "ipv4-end-point.h"
-#include "ipv4-l3-protocol.h"
+#include "ipv4-route.h"
+#include "ipv4-routing-protocol.h"
 #include "ipv6-end-point-demux.h"
 #include "ipv6-end-point.h"
 #include "ipv6-l3-protocol.h"
+#include "ipv6-route.h"
 #include "ipv6-routing-protocol.h"
 #include "rtt-estimator.h"
 #include "tcp-congestion-ops.h"
@@ -37,17 +39,16 @@
 
 #include "ns3/assert.h"
 #include "ns3/boolean.h"
-#include "ns3/ipv4-route.h"
-#include "ns3/ipv6-route.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/nstime.h"
-#include "ns3/object-vector.h"
+#include "ns3/object-map.h"
 #include "ns3/packet.h"
 #include "ns3/simulator.h"
 
 #include <iomanip>
 #include <sstream>
+#include <unordered_map>
 #include <vector>
 
 namespace ns3
@@ -72,30 +73,33 @@
 TypeId
 TcpL4Protocol::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::TcpL4Protocol")
-                            .SetParent<IpL4Protocol>()
-                            .SetGroupName("Internet")
-                            .AddConstructor<TcpL4Protocol>()
-                            .AddAttribute("RttEstimatorType",
-                                          "Type of RttEstimator objects.",
-                                          TypeIdValue(RttMeanDeviation::GetTypeId()),
-                                          MakeTypeIdAccessor(&TcpL4Protocol::m_rttTypeId),
-                                          MakeTypeIdChecker())
-                            .AddAttribute("SocketType",
-                                          "Socket type of TCP objects.",
-                                          TypeIdValue(TcpCubic::GetTypeId()),
-                                          MakeTypeIdAccessor(&TcpL4Protocol::m_congestionTypeId),
-                                          MakeTypeIdChecker())
-                            .AddAttribute("RecoveryType",
-                                          "Recovery type of TCP objects.",
-                                          TypeIdValue(TcpPrrRecovery::GetTypeId()),
-                                          MakeTypeIdAccessor(&TcpL4Protocol::m_recoveryTypeId),
-                                          MakeTypeIdChecker())
-                            .AddAttribute("SocketList",
-                                          "The list of sockets associated to this protocol.",
-                                          ObjectVectorValue(),
-                                          MakeObjectVectorAccessor(&TcpL4Protocol::m_sockets),
-                                          MakeObjectVectorChecker<TcpSocketBase>());
+    static TypeId tid =
+        TypeId("ns3::TcpL4Protocol")
+            .SetParent<IpL4Protocol>()
+            .SetGroupName("Internet")
+            .AddConstructor<TcpL4Protocol>()
+            .AddAttribute("RttEstimatorType",
+                          "Type of RttEstimator objects.",
+                          TypeIdValue(RttMeanDeviation::GetTypeId()),
+                          MakeTypeIdAccessor(&TcpL4Protocol::m_rttTypeId),
+                          MakeTypeIdChecker())
+            .AddAttribute("SocketType",
+                          "Socket type of TCP objects.",
+                          TypeIdValue(TcpCubic::GetTypeId()),
+                          MakeTypeIdAccessor(&TcpL4Protocol::m_congestionTypeId),
+                          MakeTypeIdChecker())
+            .AddAttribute("RecoveryType",
+                          "Recovery type of TCP objects.",
+                          TypeIdValue(TcpPrrRecovery::GetTypeId()),
+                          MakeTypeIdAccessor(&TcpL4Protocol::m_recoveryTypeId),
+                          MakeTypeIdChecker())
+            .AddAttribute("SocketList",
+                          "A container of sockets associated to this protocol. "
+                          "The underlying type is an unordered map, the attribute name "
+                          "is kept for backward compatibility.",
+                          ObjectMapValue(),
+                          MakeObjectMapAccessor(&TcpL4Protocol::m_sockets),
+                          MakeObjectMapChecker<TcpSocketBase>());
     return tid;
 }
 
@@ -213,7 +217,7 @@
     socket->SetCongestionControlAlgorithm(algo);
     socket->SetRecoveryAlgorithm(recovery);
 
-    m_sockets.push_back(socket);
+    m_sockets[m_socketIndex++] = socket;
     return socket;
 }
 
@@ -380,7 +384,7 @@
     }
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 TcpL4Protocol::PacketReceived(Ptr<Packet> packet,
                               TcpHeader& incomingTcpHeader,
                               const Address& source,
@@ -448,7 +452,7 @@
     }
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 TcpL4Protocol::Receive(Ptr<Packet> packet,
                        const Ipv4Header& incomingIpHeader,
                        Ptr<Ipv4Interface> incomingInterface)
@@ -519,7 +523,7 @@
     return IpL4Protocol::RX_OK;
 }
 
-enum IpL4Protocol::RxStatus
+IpL4Protocol::RxStatus
 TcpL4Protocol::Receive(Ptr<Packet> packet,
                        const Ipv6Header& incomingIpHeader,
                        Ptr<Ipv6Interface> interface)
@@ -747,36 +751,30 @@
 TcpL4Protocol::AddSocket(Ptr<TcpSocketBase> socket)
 {
     NS_LOG_FUNCTION(this << socket);
-    std::vector<Ptr<TcpSocketBase>>::iterator it = m_sockets.begin();
 
-    while (it != m_sockets.end())
+    for (auto& socketItem : m_sockets)
     {
-        if (*it == socket)
+        if (socketItem.second == socket)
         {
             return;
         }
-
-        ++it;
     }
-
-    m_sockets.push_back(socket);
+    m_sockets[m_socketIndex++] = socket;
 }
 
 bool
 TcpL4Protocol::RemoveSocket(Ptr<TcpSocketBase> socket)
 {
     NS_LOG_FUNCTION(this << socket);
-    std::vector<Ptr<TcpSocketBase>>::iterator it = m_sockets.begin();
 
-    while (it != m_sockets.end())
+    for (auto& socketItem : m_sockets)
     {
-        if (*it == socket)
+        if (socketItem.second == socket)
         {
-            m_sockets.erase(it);
+            socketItem.second = nullptr;
+            m_sockets.erase(socketItem.first);
             return true;
         }
-
-        ++it;
     }
 
     return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-l4-protocol.h ns-3.39/src/internet/model/tcp-l4-protocol.h
--- ns-3.38/src/internet/model/tcp-l4-protocol.h	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-l4-protocol.h	2023-07-05 14:23:47.857427600 -0700
@@ -27,6 +27,7 @@
 #include "ns3/sequence-number.h"
 
 #include <stdint.h>
+#include <unordered_map>
 
 namespace ns3
 {
@@ -257,12 +258,12 @@
     void DeAllocate(Ipv6EndPoint* endPoint);
 
     // From IpL4Protocol
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv4Header& incomingIpHeader,
-                                        Ptr<Ipv4Interface> incomingInterface) override;
-    enum IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
-                                        const Ipv6Header& incomingIpHeader,
-                                        Ptr<Ipv6Interface> incomingInterface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv4Header& incomingIpHeader,
+                                   Ptr<Ipv4Interface> incomingInterface) override;
+    IpL4Protocol::RxStatus Receive(Ptr<Packet> p,
+                                   const Ipv6Header& incomingIpHeader,
+                                   Ptr<Ipv6Interface> incomingInterface) override;
 
     void ReceiveIcmp(Ipv4Address icmpSource,
                      uint8_t icmpTtl,
@@ -311,10 +312,10 @@
      *
      * \return RX_CSUM_FAILED if the checksum check fails, RX_OK otherwise
      */
-    enum IpL4Protocol::RxStatus PacketReceived(Ptr<Packet> packet,
-                                               TcpHeader& incomingTcpHeader,
-                                               const Address& source,
-                                               const Address& destination);
+    IpL4Protocol::RxStatus PacketReceived(Ptr<Packet> packet,
+                                          TcpHeader& incomingTcpHeader,
+                                          const Address& source,
+                                          const Address& destination);
 
     /**
      * \brief Check if RST packet should be sent, and in case, send it
@@ -334,13 +335,15 @@
                           const Address& incomingDAddr);
 
   private:
-    Ptr<Node> m_node;                                //!< the node this stack is associated with
-    Ipv4EndPointDemux* m_endPoints;                  //!< A list of IPv4 end points.
-    Ipv6EndPointDemux* m_endPoints6;                 //!< A list of IPv6 end points.
-    TypeId m_rttTypeId;                              //!< The RTT Estimator TypeId
-    TypeId m_congestionTypeId;                       //!< The socket TypeId
-    TypeId m_recoveryTypeId;                         //!< The recovery TypeId
-    std::vector<Ptr<TcpSocketBase>> m_sockets;       //!< list of sockets
+    Ptr<Node> m_node;                //!< the node this stack is associated with
+    Ipv4EndPointDemux* m_endPoints;  //!< A list of IPv4 end points.
+    Ipv6EndPointDemux* m_endPoints6; //!< A list of IPv6 end points.
+    TypeId m_rttTypeId;              //!< The RTT Estimator TypeId
+    TypeId m_congestionTypeId;       //!< The socket TypeId
+    TypeId m_recoveryTypeId;         //!< The recovery TypeId
+    std::unordered_map<uint64_t, Ptr<TcpSocketBase>>
+        m_sockets;             //!< Unordered map of socket IDs and corresponding sockets
+    uint64_t m_socketIndex{0}; //!< index of the next socket to be created
     IpL4Protocol::DownTargetCallback m_downTarget;   //!< Callback to send packets over IPv4
     IpL4Protocol::DownTargetCallback6 m_downTarget6; //!< Callback to send packets over IPv6
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-ledbat.cc ns-3.39/src/internet/model/tcp-ledbat.cc
--- ns-3.38/src/internet/model/tcp-ledbat.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-ledbat.cc	2023-07-05 14:23:47.857427600 -0700
@@ -105,7 +105,7 @@
 };
 
 void
-TcpLedbat::InitCircBuf(struct OwdCircBuf& buffer)
+TcpLedbat::InitCircBuf(OwdCircBuf& buffer)
 {
     NS_LOG_FUNCTION(this);
     buffer.buffer.clear();
@@ -147,7 +147,7 @@
 }
 
 uint32_t
-TcpLedbat::MinCircBuf(struct OwdCircBuf& b)
+TcpLedbat::MinCircBuf(OwdCircBuf& b)
 {
     NS_LOG_FUNCTION_NOARGS();
     if (b.buffer.empty())
@@ -239,7 +239,7 @@
 }
 
 void
-TcpLedbat::AddDelay(struct OwdCircBuf& cb, uint32_t owd, uint32_t maxlen)
+TcpLedbat::AddDelay(OwdCircBuf& cb, uint32_t owd, uint32_t maxlen)
 {
     NS_LOG_FUNCTION(this << owd << maxlen << cb.buffer.size());
     if (cb.buffer.empty())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-ledbat.h ns-3.39/src/internet/model/tcp-ledbat.h
--- ns-3.38/src/internet/model/tcp-ledbat.h	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-ledbat.h	2023-07-05 14:23:47.857427600 -0700
@@ -139,10 +139,10 @@
      *
      * \param buffer The buffer to be initialised
      */
-    void InitCircBuf(struct OwdCircBuf& buffer);
+    void InitCircBuf(OwdCircBuf& buffer);
 
     /// Filter function used by LEDBAT for current delay
-    typedef uint32_t (*FilterFunction)(struct OwdCircBuf&);
+    typedef uint32_t (*FilterFunction)(OwdCircBuf&);
 
     /**
      * \brief Return the minimum delay of the buffer
@@ -150,7 +150,7 @@
      * \param b The buffer
      * \return The minimum delay
      */
-    static uint32_t MinCircBuf(struct OwdCircBuf& b);
+    static uint32_t MinCircBuf(OwdCircBuf& b);
 
     /**
      * \brief Return the value of current delay
@@ -174,7 +174,7 @@
      * \param owd The new delay
      * \param maxlen The maximum permitted length
      */
-    void AddDelay(struct OwdCircBuf& cb, uint32_t owd, uint32_t maxlen);
+    void AddDelay(OwdCircBuf& cb, uint32_t owd, uint32_t maxlen);
 
     /**
      * \brief Update the base delay buffer
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/internet/model/tcp-option-sack-permitted.cc ns-3.39/src/internet/model/tcp-option-sack-permitted.cc
--- ns-3.38/src/internet/model/tcp-option-sack-permitted.cc	2023-03-16 20:54:23.624868600 -0700
+++ ns-3.39/src/internet/model/tcp-option-sack-permitted.cc	2023-07-05 14:23:47.857427600 -0700
@@ -24,7 +24,6 @@
 #include "tcp-option-sack-permitted.h"
 
 #include "ns3/log.h"
-#include "ns3/tcp-header.h"
 
 namespace ns3
 {
